---
type: api
title: Get multiple documents
description: **All methods and paths for this operation:**
url: https://www.elastic.co/elastic/docs-builder/docs/4493/api/doc/elasticsearch/v9/operation/operation-mget
resource: https://www.elastic.co/elastic/docs-builder/docs/4493/api/doc/elasticsearch/v9/operation/operation-mget
products:
  - Elasticsearch
---

# Get multiple documents


Availability: Generally available since 1.3

## Paths

- `POST` (also `GET`) `/{index}/_mget`
- `POST` (also `GET`) `/_mget`

#### Path parameters

- `index` (string) — optional, leave it out to use `/_mget`
  Name of the index to retrieve documents from when `ids` are specified, or when a document in the `docs` array does not specify an index.

## Description

Get multiple JSON documents by ID from one or more indices.
If you specify an index in the request URI, you only need to specify the document IDs in the request body.
To ensure fast responses, this multi get (mget) API responds with partial results if one or more shards fail.

**Filter source fields**

By default, the `_source` field is returned for every document (if stored).
Use the `_source` and `_source_include` or `source_exclude` attributes to filter what fields are returned for a particular document.
You can include the `_source`, `_source_includes`, and `_source_excludes` query parameters in the request URI to specify the defaults to use when there are no per-document instructions.

**Get stored fields**

Use the `stored_fields` attribute to specify the set of stored fields you want to retrieve.
Any requested fields that are not stored are ignored.
You can include the `stored_fields` query parameter in the request URI to specify the defaults to use when there are no per-document instructions.

## Required authorization

- Index privileges: `read`

## Authentication

- Api key: `Authorization: <value>`
  Elasticsearch APIs support key-based authentication.
  You must create an API key and use the encoded value in the request header.
  For example:
  
  
  ```
  curl -X GET "${ES_URL}/_cat/indices?v=true" \
    -H "Authorization: ApiKey ${API_KEY}"
  ```
  
  To get API keys, use the `/_security/api_key` APIs.
- Basic: `Authorization: Basic <credentials>`
- Bearer: `Authorization: Bearer <token>`
  Elasticsearch APIs support the use of bearer tokens in the `Authorization` HTTP header to authenticate with the API.
  For examples, refer to [Token-based authentication services](https://www.elastic.co/docs/deploy-manage/users-roles/cluster-or-deployment-auth/token-based-authentication-services)

## Query string parameters

- `preference` (string) — optional
  Specifies the node or shard the operation should be performed on. Random by default.
- `realtime` (boolean · default: true) — optional
  If `true`, the request is real-time as opposed to near-real-time.
- `refresh` (boolean · default: false) — optional
  If `true`, the request refreshes relevant shards before retrieving documents.
- `routing` (union oneOf) — optional
  Custom value used to route operations to a specific shard.
Not allowed when `index.slice.enabled` is `true` for the target index; use `_slice` instead.
  One of: `string[]` or `string`
- `_source` (union oneOf) — optional
  True or false to return the `_source` field or not, or a list of fields to return.
  One of: `boolean` or `string`
- `_source_excludes` (union oneOf) — optional
  A comma-separated list of source fields to exclude from the response.
You can also use this parameter to exclude fields from the subset specified in `_source_includes` query parameter.
  One of: `string[]` or `string`
- `_source_includes` (union oneOf) — optional
  A comma-separated list of source fields to include in the response.
If this parameter is specified, only these source fields are returned. You can exclude fields from this subset using the `_source_excludes` query parameter.
If the `_source` parameter is `false`, this parameter is ignored.
  One of: `string[]` or `string`
- `stored_fields` (string · default: false) — optional
  If `true`, retrieves the document fields stored in the index rather than the document `_source`.

## Request body

`application/json`

- `docs` (object[]) — optional
  The documents you want to retrieve. Required if no index is specified in the request URI.
  - `_id` (string) — required
    The unique document ID.
  - `_index` (string) — optional
    The index that contains the document.
  - `routing` (string) — optional
    The key for the primary shard the document resides on. Required if routing is used during indexing.
  - `_source` (union) — optional
    If `false`, excludes all _source fields.
  - `stored_fields` (string) — optional
    The stored fields you want to retrieve.
  - `version` (number) — optional
  - `version_type` (enum) — optional
    

Supported values include:
  - `internal`: Use internal versioning that starts at 1 and increments with each update or delete.
  - `external`: Only index the document if the specified version is strictly higher than the version of the stored document or if there is no existing document.
  - `external_gte`: Only index the document if the specified version is equal or higher than the version of the stored document or if there is no existing document.
NOTE: The `external_gte` version type is meant for special use cases and should be used with care.
If used incorrectly, it can result in loss of data.
    Values: `internal`, `external`, `external_gte`
- `ids` (string) — optional
  The IDs of the documents you want to retrieve. Allowed when the index is specified in the request URI.

## Response

`application/json`

- `docs` (union oneOf[])
  The response includes a docs array that contains the documents in the order specified in the request.
The structure of the returned documents is similar to that returned by the get API.
If there is a failure getting a particular document, the error is included in place of the document.
  - **{ found, fields, _ignored, … }**
    - `_index` (string)
      The name of the index the document belongs to.
    - `fields` (map string to object)
      If the `stored_fields` parameter is set to `true` and `found` is `true`, it contains the document fields stored in the index.
    - `_ignored` (string[])
    - `found` (boolean)
      Indicates whether the document exists.
    - `_id` (string)
      The unique identifier for the document.
    - `_primary_term` (number)
      The primary term assigned to the document for the indexing operation.
    - `_routing` (string)
      The explicit routing, if set.
    - `_seq_no` (number)
      The sequence number assigned to the document for the indexing operation.
Sequence numbers are used to ensure an older version of a document doesn't overwrite a newer version.
    - `_source` (object)
      If `found` is `true`, it contains the document data formatted in JSON.
If the `_source` parameter is set to `false` or the `stored_fields` parameter is set to `true`, it is excluded.
    - `_version` (number)
      The document version, which is ncremented each time the document is updated.
  - **{ error }**
    - `error` (object)
      - `type` (string)
        The type of error
      - `reason` (union string) — nullable
        A human-readable explanation of the error, in English.
        One of: `string`
      - `stack_trace` (string)
        The server stack trace. Present only if the `error_trace=true` parameter was sent with the request.
      - `caused_by` (object) — recursive
        Same fields as `error` in `{ error }`
      - `root_cause` (object[]) — recursive
        Same fields as `error` in `{ error }`
      - `suppressed` (object[]) — recursive
        Same fields as `error` in `{ error }`
    - `_id` (string)
    - `_index` (string)
## Code examples

#### Console

```console
POST /my-index-000001/_mget
{
  "docs": [
    {
      "_id": "1"
    },
    {
      "_id": "2"
    }
  ]
}
```

#### JavaScript

```javascript
const response = await client.mget({
  index: "my-index-000001",
  docs: [
    {
      _id: "1",
    },
    {
      _id: "2",
    },
  ],
});
```

#### Python

```python
resp = client.mget(
    index="my-index-000001",
    docs=[
        {
            "_id": "1"
        },
        {
            "_id": "2"
        }
    ],
)
```

#### curl

```curl
curl -X POST "$ELASTICSEARCH_URL/my-index-000001/_mget" \
  -H "Authorization: ApiKey $ELASTIC_API_KEY" \
  -H "Content-Type: application/json" \
  -d '{
    "docs": [
      {
        "_id": "1"
      },
      {
        "_id": "2"
      }
    ]
  }'
```

#### Java

```java
client.mget(m -> m
    .docs(List.of(MultiGetOperation.of(mu -> mu
            .id("1")
        ),MultiGetOperation.of(mu -> mu
            .id("2")
        )))
    .index("my-index-000001")
);
```

#### C#

```c#
var response = await client
    .MultiGetAsync<MyDocument>(d1 => d1
        .Index("my-index-000001")
        .Docs(d2 => d2
            .Id("1"), d2 => d2
            .Id("2")
        )
    );
```

#### PHP

```php
$resp = $client->mget([
    "index" => "my-index-000001",
    "body" => [
        "docs" => array(
            [
                "_id" => "1",
            ],
            [
                "_id" => "2",
            ],
        ),
    ],
]);
```

#### Ruby

```ruby
response = client.mget(
  index: "my-index-000001",
  body: {
    "docs": [
      {
        "_id": "1"
      },
      {
        "_id": "2"
      }
    ]
  }
)
```

